/*
*	System error manager
*
*	Nicolas Christopoulos
*
*	This program is distributed under the terms of the GPL v2.0 or later
*	Download the GNU Public License (GPL) from www.gnu.org
*/

#include "panic.h"

static char preload_panic_buffer[1024];

/**
*/
void	panic(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	vsprintf(preload_panic_buffer, fmt, ap);
	va_end(ap);
	
	fprintf(stderr, "\n\nPANIC: %s\a\n\n", preload_panic_buffer);
	fflush(stderr);
	exit(1);
}

/**
*/
void	warning(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	vsprintf(preload_panic_buffer, fmt, ap);
	va_end(ap);
	
	fprintf(stderr, preload_panic_buffer);
}

/**
*/
void	debug(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	strcpy(preload_panic_buffer,"DEBUG: ");
	vsprintf(&preload_panic_buffer[7], fmt, ap);
	va_end(ap);
	
	fprintf(stderr, preload_panic_buffer);
}



