/*
*/

#include "term.h"
#include "keys.h"
#include "buffer.h"
#include <unistd.h>

#define	TERM_WAIT	25

/*
*/
void	sbp_redraw(buf_t *buf, int c)
{
	int		x, y;

	display_buf(buf);
	y = cur_line(buf);
	x = cur_col(buf);
	printf("\033[%d;1H\033[47m\033[2K\033[30m line: %-3d col: %-3d key: %d, 0x%04X \033[40m\033[37m", term_height()-1, y+1, x+1, c, c);
	term_setxy(x,y);
	fflush(stdout);
}

/*
*/
int main(int argc, char *argv[])
{
	int		c = 0;
	buf_t	*buf;

	term_init();
	buf = create_buf();

	sbp_redraw(buf, c);

	do	{
		// check events
		if	( term_events() )	{
			while ( term_events() );
			if	( !term_haskey() )
				continue;
			}
		else	{
			usleep(TERM_WAIT*1000);
			continue;
			}

		// keys
		while ( term_haskey() )	{
			c = term_popkey();
			switch ( c )	{
			case	0:
				break;
			case	SB_KEY_BACKSPACE:
				del_one_char_back(buf);
				break;
			case	SB_KEY_DELETE:
				del_one_char(buf);
				break;
			case	SB_KEY_LEFT:
				if	( buf->pos )
					buf->pos --;
				break;
			case	SB_KEY_RIGHT:
				if	( buf->pos < buf->len )
					buf->pos ++;
				break;
			default:
				insert_char(buf, c);
				};
			}

		sbp_redraw(buf, c);

		} while ( c != 27 && c >= 0 );

	destroy_buf(buf);
	term_restore();
	return 0;
}
