char *help_page_f=
">> File system\n"
"_______________________________________________________________________\n"
"\n"
"Special file names:\n"
"\n"
"\"COM1:[speed]\" - Serial port 1\n"
"\"COM2:[speed]\" - Serial port 2\n"
"                 The same for COM3..COM9\n"
"\n"
"\"PDOC:filename\"\n"
"  Compressed PDOC files for PalmOS or PDB/PDOC files on other systems.\n"
"  PDOCFS opens and uncompress the file on OPEN; and compress the\n"
"  file on CLOSE. So, it will use a lot of memory and time (its depended\n"
"  on size of the data).\n"
"\n"
"\"MEMO:memo-title\"\n"
"  MemoDB of PalmOS or regular file on other systems.\n"
"  Memo records (virtual files) are limited to 3935 bytes\n"
"\n"
"\"SOCL:server:port\"\n"
"  Socket client. Actually a telnet client.\n"
"\n"
"Example:\n"
"\n"
"OPEN \"COM1:\" AS #1\n"
"\n"
"OPEN \"COM2:38400\" AS #2\n"
"\n"
"_______________________________________________________________________\n"
"\n"
"FREEFILE\n"
"\n"
"Returns an unused file handle\n"
"_______________________________________________________________________\n"
"\n"
"OPEN file [FOR {INPUT|OUTPUT|APPEND}] AS #fileN\n"
"\n"
"Makes a file or device available for sequential input, sequential\n"
"output.\n"
"\n"
"file   - A string expression that follows OS file naming conventions.\n"
"\n"
"fileN  - A file-handle (integer 1 to 256).\n"
"\n"
"FOR -\n"
"      INPUT    Sequential input\n"
"      OUTPUT   Sequential output\n"
"      APPEND   Sequential output, beginning at current EOF\n"
"\n"
"The files are always opened as shared.\n"
"_______________________________________________________________________\n"
"\n"
"CLOSE #fileN\n"
"\n"
"Close a file or device\n"
"_______________________________________________________________________\n"
"\n"
"TLOAD file, BYREF var [, type]\n"
"\n"
"Loads a text file into array variable.\n"
"Each text-line is an array element.\n"
"\n"
"file   - A string expression that follows OS file naming conventions.\n"
"\n"
"var    - Any variable\n"
"\n"
"type   - 0 = load into array (default)\n"
"         1 = load into string\n"
"_______________________________________________________________________\n"
"\n"
"TSAVE file, var\n"
"\n"
"Writes an array to a text file.\n"
"Each array element is a text-line.\n"
"\n"
"file   - A string expression that follows OS file naming conventions.\n"
"\n"
"var    - An array variable or a string variable. Expressions are\n"
"         not allowed for memory reasons.\n"
"_______________________________________________________________________\n"
"\n"
"EXIST(file)\n"
"\n"
"Returns true if the file exists\n"
"\n"
"file   - A string expression that follows OS file naming conventions.\n"
"_______________________________________________________________________\n"
"\n"
"ACCESS(file)\n"
"\n"
"Returns the access rights of the file.\n"
"\n"
"file   - A string expression that follows OS file naming conventions.\n"
"\n"
"The return-value is the permissions of the file as them as specified\n"
"on GNU's manual (chmod() and stat() system calls)\n"
"\n"
"The bits (in octal):\n"
"04000 set user ID on execution\n"
"02000 set group ID on execution\n"
"01000 sticky bit\n"
"00400 read by owner\n"
"00200 write by owner\n"
"00100 execute/search by owner\n"
"00040 read by group\n"
"00020 write by group\n"
"00010 execute/search by group\n"
"00004 read by others\n"
"00002 write by others\n"
"00001 execute/search by others\n"
"\n"
"Notes:\n"
"    * PalmOS: the return value is always 0777\n"
"    * DOS: the return value is depended on DJGPP's stat() function\n"
"      Possible, Unix compatible.\n"
"    * Windows: the return value is depended on Cygnus's stat() function\n"
"      Possible, Unix compatible.\n"
"\n"
"Example:\n"
"\n"
"IF ACCESS(\"/bin/sh\") AND 0o4 THEN\n"
"    PRINT \"I can read it!\"\n"
"ENDIF\n"
"\n"
"See also: CHMOD\n"
"_______________________________________________________________________\n"
"\n"
"ISFILE(file) - Returns true if the file is a regular file\n"
"ISDIR(file)  - Returns true if the filename is a directory\n"
"ISLINK(file) - Returns true if the filename is a link\n"
"\n"
"file   - A string expression that follows OS file naming conventions.\n"
"_______________________________________________________________________\n"
"\n"
"CHMOD file, mode\n"
"\n"
"Change permissions of a file\n"
"\n"
"file   - A string expression that follows OS file naming conventions.\n"
"\n"
"mode   - The mode is compatible with the chmod()'s 'mode' parameter\n"
"         as its described on GNU's manual.\n"
"         See ACCESS() for more information.\n"
"\n"
"Examples:\n"
"\n"
"' Make myfile available to anyone (read/write)\n"
"CHMOD \"myfile.bas\", &o666\n"
"\n"
"' Make myfile available to anyone (execute/read/write)\n"
"CHMOD \"myfile.bas\", &o777\n"
"_______________________________________________________________________\n"
"\n"
"EOF(fileN)\n"
"\n"
"Returns true if the file pointer is at end of the file.\n"
"\n"
"For COMx and SOCL VFS it returns true if the connection is broken.\n"
"_______________________________________________________________________\n"
"\n"
"PRINT #fileN, [USING...] ...\n"
"\n"
"Write string to a file\n"
"\n"
"The syntax is the same with the PRINT command.\n"
"_______________________________________________________________________\n"
"\n"
"LINE INPUT [#fileN{,|;}] var\n"
"or\n"
"LINEINPUT [#fileN{,|;}] var\n"
"\n"
"Reads a whole text line from file or console.\n"
"_______________________________________________________________________\n"
"\n"
"INPUT(len[,fileN])\n"
"\n"
"Reads 'len' bytes from file or console (if fileN is omitted).\n"
"_______________________________________________________________________\n"
"\n"
"INPUT #fileN; var1 [,delim] [, var2 [,delim]] ...\n"
"\n"
"Reads data from file\n"
"_______________________________________________________________________\n"
"\n"
"SEEK #fileN; pos\n"
"\n"
"Sets file position for the next read/write\n"
"_______________________________________________________________________\n"
"\n"
"SEEK(fileN)\n"
"\n"
"Returns the current file position\n"
"_______________________________________________________________________\n"
"\n"
"LOF(fileN)\n"
"\n"
"Returns the length of file in bytes\n"
"\n"
"For devices; returns the number of available data\n"
"_______________________________________________________________________\n"
"\n"
"KILL \"file\"\n"
"\n"
"Deletes the specified file\n"
"_______________________________________________________________________\n"
"\n"
"WRITE #fileN; var1 [, ...]\n"
"READ #fileN; var1 [, ...]\n"
"\n"
"The READ/WRITE command set is used to store variables to a file as\n"
"binary data.\n"
"\n"
"The common problem with INPUT/PRINT set is there are many conficts with\n"
"datas. \n"
"\n"
"Example:\n"
"PRINT #1; \"Hello, world\"\n"
"\n"
"You have wrote only one string and you want read it in one variable,\n"
"but this is impossible for INPUT command to understand it, because\n"
"INPUT finds the separator comma, so it thinks there are two variables\n"
"not one.\n"
"\n"
"So, now, you can store arrays, strings etc and what is you write is\n"
"what you will read the next time.\n"
"\n"
"BTW its faster too.\n"
"\n"
"Notes:\n"
"* The parameters can be variables ONLY.\n"
"* Its very bad idea to mixed READ/WRITE commands with INPUT/PRINT\n"
"  commands in the same file.\n"
"_______________________________________________________________________\n"
"\n"
"COPY \"file\", \"newfile\"\n"
"\n"
"Makes a copy of specified file to the 'newfile'\n"
"_______________________________________________________________________\n"
"\n"
"RENAME \"file\", \"newfile\"\n"
"\n"
"Renames the specified file\n"
"_______________________________________________________________________\n"
"\n"
"MKDIR dir\n"
"CHDIR dir\n"
"RMDIR dir\n"
"\n"
"Notes:\n"
"Non-PalmOS only.\n"
"_______________________________________________________________________\n"
"\n"
"DIRWALK directory [, wildcards] [USE ...]\n"
"_______________________________________________________________________\n"
"\n"
"FILES(wildcards)\n"
"\n"
"Returns an array with the filenames.\n"
"\n"
"If there is no files returns an empty array.\n"
"\n"
"Example:\n"
"\n"
"? FILES(\"*\")\n"
"\n"
"Notes: \n"
"* For PalmOS returns only the user-files.\n"
"* To use file on MEMO or PDOC or any other virtual file system you must\n"
"  use FILES(\"VFSx:*\")\n"
"\n"
"  Example:\n"
"  PRINT FILES(\"MEMO:*\")\n"
"\n"
"_______________________________________________________________________\n"
"\n"
;