char *help_page_g=
">> Mathematics\n"
"_______________________________________________________________________\n"
"\n"
"All angles are in radians.\n"
"\n"
"ABS(x)              - Absolute value of x\n"
"COS(x)              - Cosine of x\n"
"SIN(x)              - Sine of x\n"
"TAN(x)              - Tangent of x\n"
"ACOS(x)             - Arc cosine of x\n"
"ASIN(x)             - Arc sine of x\n"
"ATN(x) or ATAN(x)   - Arc tangent of x\n"
"ATAN2(x,y)          - Arc tangent of two variables\n"
"\n"
"Hyperbolic functions:\n"
"\n"
"COSH(x),  SINH(x),  TANH(x)\n"
"ACOSH(x), ASINH(x), ATANH(x)\n"
"\n"
"EXP(x)              - the value of e raised to the power of x\n"
"LOG(x)              - natural logarithm of x\n"
"LOG10(x)            - the base-10 logarithm of x\n"
"\n"
"POW(x,y)            - x raised to power of y\n"
"SQR(x)              - square root of x\n"
"\n"
"INT(x)              - rounds x downwards to the nearest integer\n"
"FIX(x)              - rounds x upwards to the nearest integer\n"
"FLOOR(x)            - largest integer value not greater than x\n"
"CEIL(x)             - smallest integral value not less than x\n"
"FRAC(x)             - fractional part of x\n"
"\n"
"ROUND(x[,decs])     - rounds the x to the nearest integer or number \n"
"                      with 'decs' decimal digits.\n"
"\n"
"SGN(x)              - sign of x (+1 for positive, -1 for negative\n"
"                      and 0 for zero)\n"
"\n"
"DEG(x)              - radians to degrees\n"
"RAD(x)              - degrees to radians\n"
"_______________________________________________________________________\n"
"\n"
"MAX(...), MIN(...)\n"
"ABSMIN(...), ABSMAX(...)\n"
"\n"
"Maximum/Minimum value of parameters. Parameters can be anything \n"
"(arrays, ints, reals, strings).\n"
"\n"
"ABSMIN/ABSMAX returns the absolute min/max value.\n"
"\n"
"Example:\n"
"? MAX(3,4,8)\n"
"? MIN(array(),2,3)\n"
"? MAX(\"abc\",\"def\")\n"
"_______________________________________________________________________\n"
"\n"
"SUM(...)                - Sum of value\n"
"\n"
"SUMSQ(...)              - Sum of square value \n"
"\n"
"STATMEAN(...)           - Arithmetical mean\n"
"\n"
"STATMEANDEV(...)        - Mean deviation\n"
"\n"
"STATSPREADS(...)        - Sample spread\n"
"\n"
"STATSPREADP(...)        - Population spread\n"
"\n"
"Notes:\n"
"Sample standard deviation:     SQR(STATSPREADS(array))\n"
"Population standard deviation: SQR(STATSPREADP(array))\n"
"_______________________________________________________________________\n"
"\n"
"LINEQN(A, B [, toler])\n"
"\n"
"Returns an array with the values of the unknowns.\n"
"This function solves equations by using the Gauss-Jordan method.\n"
"\n"
"A = equations\n"
"B = results\n"
"toler = tolerance number \n"
"    (the absolute value of the lowest acceptable number)\n"
"    default = 0 = none\n"
"\n"
"    |x| <= toler : x = 0\n"
"\n"
"Note: The result is a matrix Nx1. For the SB that array is \n"
"      two-dimension array.\n"
"_______________________________________________________________________\n"
"\n"
"INVERSE(A)\n"
"\n"
"returns the inverse matrix of A.\n"
"_______________________________________________________________________\n"
"\n"
"DETERM(A[, toler])\n"
"\n"
"Determinant of A\n"
"\n"
"toler = tolerance number\n"
"  (the absolute value of the lowest acceptable number)\n"
"  default = 0 = none\n"
"\n"
"  |x| <= toler : x = 0\n"
"_______________________________________________________________________\n"
"\n"
"ROOT low, high, segs, maxerr, BYREF result, BYREF errcode USE expr\n"
"_______________________________________________________________________\n"
"\n"
"DERIV x, maxtries, maxerr, BYREF result, BYREF errcode USE expr\n"
"_______________________________________________________________________\n"
"\n"
"DIFFEQN x0, y0, xf, maxseg, maxerr, BYREF yf, BYREF er USE expr\n"
"\n"
"Runge-Kutta method\n"
"\n"
"_______________________________________________________________________\n"
"\n"
">> 2D Algebra\n"
"_______________________________________________________________________\n"
"\n"
"SEGCOS(Ax,Ay,Bx,By,Cx,Cy,Dx,Dy)\n"
"SEGSIN(Ax,Ay,Bx,By,Cx,Cy,Dx,Dy)\n"
"\n"
"Sinus or cosine of 2 line segments (A->B, C->D).\n"
"_______________________________________________________________________\n"
"\n"
"PTDISTSEG(Bx,By,Cx,Cy,Ax,Ay)\n"
"\n"
"Distance of point A from line segment B-C\n"
"\n"
"PTDISTLN(Bx,By,Cx,Cy,Ax,Ay)\n"
"\n"
"Distance of point A from line B, C\n"
"_______________________________________________________________________\n"
"\n"
"PTSIGN(Ax,Ay,Bx,By,Qx,Qy)\n"
"\n"
"The sign of point Q from line segment A->B\n"
"_______________________________________________________________________\n"
"\n"
"SEGLEN(Ax,Ay,Bx,By)\n"
"\n"
"Length of line segment\n"
"_______________________________________________________________________\n"
"\n"
"POLYAREA(poly)\n"
"\n"
"Area of polyline\n"
"_______________________________________________________________________\n"
"\n"
"POLYEXT poly(), BYREF xmin, BYREF ymin, BYREF xmax, BYREF ymax\n"
"\n"
"Returns the polyline's extents\n"
"_______________________________________________________________________\n"
"\n"
"INTERSECT Ax, Ay, Bx, By,\n"
"          Cx, Cy, Dx, Dy,\n"
"          BYREF type, BYREF Rx, BYREF Ry\n"
"\n"
"Calculates the intersection of the two line segments A-B and C-D\n"
"\n"
"Returns:\n"
"Rx,Ry = cross\n"
"\n"
"type = cross-type\n"
"0 = No cross (R = external cross)\n"
"1 = One cross\n"
"2 = Parallel\n"
"3 = Parallel (many crosses)\n"
"4 = The cross is one of the line segments edges.\n"
"_______________________________________________________________________\n"
"\n"
"2D: 3x3 Matrices\n"
"\n"
"M3IDENT	BYREF m3x3\n"
"\n"
"M3ROTATE BYREF m3x3, angle, x, y\n"
"\n"
"M3SCALE BYREF m3x3, x, y, fx, fy\n"
"\n"
"M3TRANS BYREF m3x3, x, y\n"
"\n"
"M3APPLY m3x3, BYREF poly\n"
"\n"
"Example:\n"
"\n"
"DIM poly(24)\n"
"DIM M(2,2)\n"
"...\n"
"\n"
"M3IDENT M\n"
"M3ROTATE M, pi/2, 0, 0\n"
"M3SCALE M, 0, 0, 1.24, 1.24\n"
"\n"
"' Draw the original polyline\n"
"DRAWPOLY poly\n"
"\n"
"' Draw the polyline\n"
"' rotated by pi/2 from 0,0 and scaled by 1.24 \n"
"M3APPLY M, poly\n"
"DRAWPOLY poly\n"
"\n"
"_______________________________________________________________________\n"
"\n"
;