char *help_page_h=
">> Strings\n"
"_______________________________________________________________________\n"
"\n"
"LEN(s)              - length of string\n"
"SPC(n)/SPACE(n)     - returns a string of 'n' spaces\n"
"BIN(x)              - binary string-value of x\n"
"OCT(x)              - octal string-value of x\n"
"HEX(x)              - hexadecimal string-value of x\n"
"VAL(s)              - numeric value of string s\n"
"STR(x)              - convert x to string\n"
"ASC(s)              - ASCII code of first character of s\n"
"CHR(x)              - returns one-char string of character with\n"
"                      ASCII code x\n"
"_______________________________________________________________________\n"
"\n"
"LOWER(s), UPPER(s)\n"
"or\n"
"LCASE(s), UCASE(s)\n"
"\n"
"Converts the string s to lower/upper case\n"
"\n"
"Example:\n"
"? LOWER(\"Hi\"):REM hi\n"
"? UPPER(\"Hi\"):REM HI\n"
"_______________________________________________________________________\n"
"\n"
"LTRIM(s)    - Removes leading white-spaces from string s\n"
"RTRIM(s)    - Removes /trailing white-spaces from string s\n"
"TRIM(s)     - Removes leading/trailing white-spaces from string s\n"
"\n"
"Example:\n"
"\n"
"? LEN(LTRIM(\"  Hi\")):REM 2\n"
"\n"
"TRIM is equal to LTRIM(RTRIM(s))\n"
"_______________________________________________________________________\n"
"\n"
"SQUEEZE(s)\n"
"\n"
"Removes the leading/trailing and duplicated white-spaces\n"
"\n"
"Example:\n"
"? \"[\"; SQUEEZE(\" Hi  there \"); \"]\"\n"
"\n"
"Result:\n"
"[Hi there]\n"
"_______________________________________________________________________\n"
"\n"
"ENCLOSE(str[, pair])\n"
"\n"
"Encloses a string.\n"
"The default pair is \"\"\n"
"\n"
"Example:\n"
"? enclose(\"abc\", \"()\")\n"
"\n"
"Result:\n"
"(abc)\n"
"_______________________________________________________________________\n"
"\n"
"DISCLOSE(str[, pairs [, ignore-pairs]])\n"
"\n"
"Discloses a string.\n"
"\n"
"Default pairs and ignore pairs\n"
"\n"
"First \n"
"non white-space \n"
"character           Check   Ignore\n"
"--------------------------------------------\n"
"\"                   \"\"      ''\n"
"'                   ''      \"\"\n"
"(                   ()      \"\"''\n"
"[                   []      \"\"''\n"
"{                   {}      \"\"''\n"
"<                   <>      \"\"''\n"
"\n"
"Otherwise:\n"
"\"                   \"\"      ''\n"
"\n"
"Example:\n"
"\n"
"s = \"abc (abc)\"\n"
"? s; tab(26); disclose(s, \"()\")\n"
"' prints abc\n"
"\n"
"s = \"abc (a(bc))\"\n"
"? s; tab(26); disclose(s, \"()\"); tab(40); disclose(disclose(s, \"()\"), \"()\")\n"
"' prints a(bc), bc\n"
"\n"
"s = \"abc (a='(bc)')\"\n"
"? s; tab(26); disclose(s, \"()\", \"''\"); tab(40); &\n"
"    disclose(disclose(s, \"()\", \"''\"), \"()\", \"''\")\n"
"' prints a='(bc)', nothing\n"
"_______________________________________________________________________\n"
"\n"
"LEFT(s[,n]), RIGHT(s[,n])\n"
"\n"
"Returns the n number of leftmost/rightmost chars of string s\n"
"If n is not specified, the SB uses 1\n"
"_______________________________________________________________________\n"
"\n"
"LEFTOF(s1,s2),\n"
"RIGHTOF(s1,s2)\n"
"\n"
"Returns the left/right part of s1 at the position of the first \n"
"occurrence of the string s2 into string s1\n"
"\n"
"Note: s2 does not included on new string.\n"
"_______________________________________________________________________\n"
"\n"
"LEFTOFLAST(s1,s2),\n"
"RIGHTOFLAST(s1,s2)\n"
"\n"
"Returns the left/right part of s1 at the position of the last \n"
"occurrence of the string s2 into string s1\n"
"\n"
"Note: s2 does not included on new string.\n"
"_______________________________________________________________________\n"
"\n"
"MID(s, start [,length])\n"
"\n"
"Returns the part (length) of the string s starting from 'start'\n"
"position\n"
"\n"
"If the 'length' parameter is omitted, MID returns the whole string\n"
"from the position 'start'.\n"
"_______________________________________________________________________\n"
"\n"
"INSTR([start,] s1, s2)\n"
"\n"
"Returns the position of the first occurrence of the string s2 into\n"
"string s1 (starting from the position 'start')\n"
"\n"
"If there is no match, INSTR returns 0\n"
"_______________________________________________________________________\n"
"\n"
"RINSTR([start,] s1, s2)\n"
"\n"
"Returns the position of the last occurrence of the string s2 into\n"
"string s1 (starting from the position 'start')\n"
"\n"
"If there is no match, RINSTR returns 0\n"
"_______________________________________________________________________\n"
"\n"
"REPLACE(source, pos, str [, len])\n"
"\n"
"Writes the 'str' into 'pos' of 'source' and returns the new string.\n"
"\n"
"This function replaces only 'len' characters. The default value of\n"
"'len' is the length of 'str'.\n"
"\n"
"Examples:\n"
"\n"
"s=\"123456\"\n"
"\n"
"' Cut\n"
"? replace(s,3,\"\",len(s))\n"
"\n"
"' Replace\n"
"? replace(s,2,\"bcd\")\n"
"\n"
"' Insert\n"
"? replace(s,3,\"cde\",0)\n"
"\n"
"' Replace & insert\n"
"? replace(s,2,\"RRI\",2)\n"
"_______________________________________________________________________\n"
"\n"
"TRANSLATE(source, what [, with])\n"
"\n"
"Translates all occurrences of the string 'what' found in the 'source'\n"
"with the string 'with' and returns the new string.\n"
"\n"
"Example:\n"
"\n"
"? Translate(\"Hello world\", \"o\", \"O\")\n"
"' displays: HellO wOrld\n"
"\n"
"_______________________________________________________________________\n"
"\n"
"CHOP(source)\n"
"\n"
"Chops off the last character of the string 'source' and returns \n"
"the result.\n"
"_______________________________________________________________________\n"
"\n"
"STRING(len,{ascii|str})\n"
"\n"
"Returns a string that is contains 'len' times of string 'str' or the \n"
"character 'ascii'.\n"
"_______________________________________________________________________\n"
"\n"
"FORMAT(format, val)\n"
"\n"
"Returns a formated string.\n"
"\n"
"Numbers:\n"
"#       Digit or space\n"
"\n"
"0       Digit or zero\n"
"\n"
"^       Stores a number in exponential format. \n"
"        Unlike QB's USING format this is a place-holder like the #.\n"
"\n"
".       The position of the decimal point.\n"
"\n"
",       Separator.\n"
"\n"
"-       Stores minus if the number is negative. \n"
"\n"
"+       Stores the sign of the number.\n"
"\n"
"Strings:\n"
"&       Stores a string expression without reformatting it.\n"
"\n"
"!       Stores only the first character of a string expression.\n"
"\n"
"\\  \\    Stores only the first n + 2 characters of a string\n"
"        expression, where n is the number of spaces between the\n"
"        two backslashes. \n"
"        Unlike QB, there can be literals inside the \\ \\. These\n"
"        literals are inserted in the final string.\n"
"\n"
"Example:\n"
"\n"
"? FORMAT(\"#,##0\", 1920.6) : REM prints 1,921\n"
"? FORMAT(\"\\  - \\\", \"abcde\") : REM prints \"abc-de\"\n"
"_______________________________________________________________________\n"
"\n"
"SPRINT var; [USING...;] ...\n"
"\n"
"Create formated string and storing it to var\n"
"\n"
"The syntax is the same with the PRINT command.\n"
"\n"
"Example:\n"
"\n"
"SPRINT s; 12.34; TAB(12); 11.23;\n"
"_______________________________________________________________________\n"
"\n"
"SINPUT src; var [, delim] [,var [, delim]] ...\n"
"\n"
"Splits the string 'src' into variables which are separated by \n"
"delimiters.\n"
"\n"
"Example:\n"
"\n"
"SINPUT \"if x>1 then y\"; vif, \" \", vcond, \"then\", vdo\n"
"? vcond, vdo\n"
"' result in monitor\n"
"' x>1   y\n"
"_______________________________________________________________________\n"
"\n"
"SPLIT string, delimiters, words() [, pairs] [USE expr]\n"
"\n"
"Returns the words of the specified string into array 'words'\n"
"\n"
"Example:\n"
"\n"
"s=\"/etc/temp/filename.ext\"\n"
"\n"
"SPLIT s, \"/.\", v()\n"
"FOR i=0 TO UBOUND(v)\n"
"  PRINT i;\" [\";v(i);\"]\"\n"
"NEXT\n"
"\n"
"displays:\n"
"0 []\n"
"1 [etc]\n"
"2 [temp]\n"
"3 [filename]\n"
"4 [ext]\n"
"_______________________________________________________________________\n"
"\n"
"JOIN words(), delimiters, string\n"
"\n"
"Returns the words of the specified string into array 'words'\n"
"\n"
"Example:\n"
"\n"
"s=\"/etc/temp/filename.ext\"\n"
"\n"
"SPLIT s, \"/.\", v()\n"
"JOIN v(), \"/\", s\n"
"PRINT \"[\";s;\"]\"\n"
"\n"
"displays:\n"
"[/etc/temp/filename/ext]\n"
"\n"
"\n"
"_______________________________________________________________________\n"
"\n"
;