char *help_page_c=
">> System\n"
"_______________________________________________________________________\n"
"\n"
"FRE(0|-1|-2|-3)\n"
"\n"
"Returns information about system memory\n"
"\n"
" 0 - free memory\n"
"-1 - largest block of integers\n"
"-2 - free stack\n"
"-3 - largest free block\n"
"\n"
"Unix only:\n"
"-10 - total RAM\n"
"-11 - used\n"
"-12 - free\n"
"-13 - shared\n"
"-14 - buffers\n"
"-15 - cached\n"
"_______________________________________________________________________\n"
"\n"
"TICKS() \n"
"\n"
"Returns the system-ticks. The tick value is depended on operating\n"
"system. \n"
"_______________________________________________________________________\n"
"\n"
"TICKSPERSEC()\n"
"\n"
"Returns the number of ticks per second\n"
"_______________________________________________________________________\n"
"\n"
"TIMER \n"
"\n"
"Returns the number of seconds from midnight\n"
"_______________________________________________________________________\n"
"\n"
"TIME\n"
"\n"
"Returns the current time as string \"HH:MM:SS\"\n"
"\n"
"_______________________________________________________________________\n"
"\n"
"DATE \n"
"\n"
"Returns the current day as string \"DD/MM/YYYY\"\n"
"_______________________________________________________________________\n"
"\n"
"JULIAN(dmy | (d,m,y))\n"
"\n"
"Returns the Julian date.\n"
"(dates must be greater than 1/1/100 AD)\n"
"\n"
"Example:\n"
"\n"
"PRINT Julian(DATE)\n"
"PRINT Julian(31, 12, 2001)\n"
"_______________________________________________________________________\n"
"\n"
"DATEDMY dmy | julian_date, BYREF d, BYREF m, BYREF y\n"
"\n"
"Returns the day, month and the year as integers.\n"
"_______________________________________________________________________\n"
"\n"
"WEEKDAY(dmy | (d,m,y) | julian_date)\n"
"\n"
"Returns the day of the week (0 = Sunday)\n"
"\n"
"Example:\n"
"\n"
"PRINT WeekDay(DATE)\n"
"PRINT WeekDay(Julian(31, 12, 2001))\n"
"PRINT WeekDay(31, 12, 2001)\n"
"_______________________________________________________________________\n"
"\n"
"DATEFMT(format, dmy | (d,m,y) | julian_date)\n"
"\n"
"Returns formated date string\n"
"\n"
"Format:\n"
"D = one or two digits of Day\n"
"DD = 2-digit day\n"
"DDD = 3-char day name\n"
"DDDD = full day name\n"
"M = 1 or 2 digits of month\n"
"MM = 2-digit month\n"
"MMM = 3-char month name\n"
"MMMM = full month name\n"
"YY = 2-digit year (2K)\n"
"YYYY = 4-digit year\n"
"\n"
"Example:\n"
"\n"
"PRINT DATEFMT(\"ddd dd, mm/yy\", \"23/11/2001\")\n"
"\n"
"REM prints \"Fri 23, 11/01\"\n"
"_______________________________________________________________________\n"
"\n"
"DELAY ms\n"
"\n"
"Delay for a specified amount of milliseconds.\n"
"_______________________________________________________________________\n"
"\n"
"SORT array [USE cmpfunc]\n"
"\n"
"Sorts an array.\n"
"\n"
"The cmpfunc (if its specified) it takes 2 vars to compare. \n"
"cmpfunc must returns\n"
"-1 if x < y\n"
"+1 if x > y\n"
" 0 if x = y\n"
"\n"
"Example:\n"
"\n"
"FUNC qscmp(x,y)\n"
"IF x=y \n"
"    qscmp=0\n"
"ELIF x>y\n"
"    qscmp=1\n"
"ELSE\n"
"    qscmp=-1\n"
"ENDIF\n"
"END\n"
"\n"
"DIM A(5)\n"
"FOR i=0 TO 5\n"
"    A(i)=RND\n"
"NEXT\n"
"SORT A USE qscmp(x,y)\n"
"_______________________________________________________________________\n"
"\n"
"SEARCH A, key, BYREF ridx [USE cmpfunc]\n"
"\n"
"Scans an array for the key.\n"
"If key is not found the SEARCH command returns (in ridx) the value \n"
"(LBOUND(A)-1). In default-base arrays that means -1.\n"
"\n"
"The cmpfunc (if its specified) it takes 2 vars to compare. \n"
"It must return 0 if x = y; non-zero if x <> y\n"
"\n"
"Example:\n"
"\n"
"FUNC cmp(x,y)\n"
"  cmp=!(x=y)\n"
"END\n"
"\n"
"DIM A(5)\n"
"FOR i=0 TO 5\n"
"    A(i)=5-i\n"
"NEXT\n"
"SEARCH A, 4, r USE cmp(x,y)\n"
"PRINT r:REM prints 1\n"
"PRINT A(r): REM prints 4\n"
"_______________________________________________________________________\n"
"\n"
"CHAIN file\n"
"\n"
"Transfers control to another SmallBASIC program.\n"
"\n"
"file - A string expression that follows OS file naming conventions;\n"
"The file must be a SmallBASIC source code file.\n"
"\n"
"Example:\n"
"\n"
"CHAIN \"PROG2.BAS\"\n"
"_______________________________________________________________________\n"
"\n"
"EXEC file\n"
"\n"
"Transfers control to another program\n"
"\n"
"This routine works like CHAIN with the execption the file can\n"
"be any executable file.\n"
"\n"
"EXEC never returns\n"
"_______________________________________________________________________\n"
"\n"
"ENVIRON \"expr\"\n"
"or\n"
"ENV \"expr\"\n"
"\n"
"Adds a variable to or deletes a variable from the current environment\n"
"variable-table.\n"
"\n"
"expr - A string expression of the form \"name=parameter\"\n"
"\n"
"If name already exists in the environment table, its current setting is\n"
"replaced with the new setting. If name does not exist, the new variable\n"
"is added.\n"
"_______________________________________________________________________\n"
"\n"
"ENVIRON(\"var\")\n"
"or\n"
"ENV(\"var\")\n"
"\n"
"Returns the value of a specified entry in the current environment\n"
"table.\n"
"\n"
"var  - A string expression of the form \"var\"\n"
"_______________________________________________________________________\n"
"\n"
"RUN cmdstr\n"
"\n"
"Loads a secondary copy of system's shell and, executes an program, or \n"
"an shell command.\n"
"\n"
"cmdstr - Shell's specific command string\n"
"\n"
"After the specified shell command or program terminates, control is\n"
"returned to the line following the RUN command.\n"
"\n"
"Notes:\n"
"    * PalmOS: The 'cmdstr' is the Creator-ID\n"
"    * PalmOS: The RUN never returns\n"
"_______________________________________________________________________\n"
"\n"
"RUN(\"command\")\n"
"\n"
"RUN() is the function version of the RUN command. The differnce is\n"
"that, the RUN() returns a string with the output of the 'command' as\n"
"an array of strings (each text-line is one element).\n"
"\n"
"Notes:\n"
"    * PalmOS: The RUN() does not supported.\n"
"    * Windows: The stdout and stderr are separated! First is the \n"
"      stdout output and following the stderr.\n"
"_______________________________________________________________________\n"
"\n"
"TRON/TROFF\n"
"\n"
"TRACE ON/OFF. When trace mechanism is ON, the SB displays each line \n"
"number as the program is executed\n"
"_______________________________________________________________________\n"
"\n"
"LOGPRINT ...\n"
"\n"
"PRINT to SB's logfile. The syntax is the same with the PRINT command.\n"
"_______________________________________________________________________\n"
"\n"
"STKDUMP\n"
"\n"
"Displays the SB's internal executor's stack\n"
"\n"
"_______________________________________________________________________\n"
"\n"
;