//---------------------------------------------------------------------------

#include <vcl.h>
#include <inifiles.hpp>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <dir.h>
#pragma hdrstop

#define	SEC(x)

#include "fabt.h"
#include "fsrc.h"
#include "fsettngs.h"
#include "pad1.h"
#include "sbpad_bcb.h"
#include "panic.h"
#include "unx_memmgr.h"
#include "keys.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

static char bcb_dir[1024];
static char bcb_srcfile[1024];
static char bcb_search[1024];
static int	bcb_cur_line;
static int	bcb_cur_col;

String bcb_ef;
String bcb_xf;
int bcb_vs;
int bcb_vwidth;
int bcb_vheight;

static char *bcb_hlpidx[] = {
"doc\\sbref.txt",
"doc\\sbms.txt",
"doc\\sbcon.txt",
"doc\\sbgraf.txt",
"doc\\sbfs.txt",
"doc\\sbsys.txt",
"doc\\sbmisc.txt",
"doc\\README.BCB",
"doc\\LICENSE"
};

//---------------------------------------------------------------------------
TFMain *FMain;
//---------------------------------------------------------------------------

#define	EVLIST_SIZE		1024
volatile event_t	evlist[EVLIST_SIZE];
volatile int		ev_head = 0, ev_tail = 0;
volatile int		ev_record = 0;
volatile int		stdout_init = 0;
volatile int		running = 0;
Graphics::TBitmap	*bmp = NULL;
typedef char * char_p;

// dev_bcb.cpp:
extern void	w32_stdout_open();
extern void	w32_stdout_close();

// pdb
extern int	SaveSBPDB(const char *fname, const char *text);
extern int	LoadSBPDB(const char *fname, char_p *text);


// SB's code declarations
extern "C" {
int		osd_events(int);
void	brun(const char *, int);
void	dump_bytecode(FILE *stream);
void	brun_load(char *fileName, int nocomp);
int		bc_get_error(void);
int		dev_init(int mode, int flags);
int		dev_restore(void);
void	memmgr_setabort(int v);
}

/*
*/
void	bcb_strfont(String s, String &name, int &size)
{
	char	*buf = strdup(s.c_str());
    char	*p;

	p = strchr(buf, ',');
    if	( p )	{
    	*p = '\0';
    	name = buf;
        size = atoi(p+1);
    	}
	else	{
    	name = buf;
        size = 9;
		}
	free(buf);
}

/*
*/
void _cdecl w32_copybmp()
{
   	Application->ProcessMessages();
	if	( stdout_init )
		FMain->imgOut->Picture->Assign(bmp);
}

/*
*	refresh request from dev_bcb
*/
void _cdecl w32_invalidate_rect()
{
	w32_copybmp();
}

/*
*	return the canvas of bmp
*/
TCanvas* _cdecl	w32_canvas(void)
{
	if	( bmp )
		return bmp->Canvas;
	return NULL;
}

/*
*	start/stop storing events
*/
void _cdecl w32_evstate(int enable)
{
	if	( enable )
		ev_head = ev_tail = 0;
	ev_record = enable;
	if	( !enable )
		ev_head = ev_tail = 0;
}

/*
*	stores an event to queue
*/
void _cdecl w32_evpush(event_t *ev)
{
	if	( ev_record )	{
		evlist[ev_tail] = *ev;
		if	( ev_tail+1 >= EVLIST_SIZE )
			ev_tail = 0;
		else
			ev_tail ++;
		}
}

/*
*	returns true if there is an event in queue (event is COPIED in the 'ev')
*/
int _cdecl w32_evget(event_t *ev)
{
	if ( ev_tail == ev_head )
		return 0;

	*ev = evlist[ev_head];
	if	( ev_head+1 >= EVLIST_SIZE )
		ev_head = 0;
	else
		ev_head ++;
	return 1;
}

/*
*/
void _cdecl w32_refresh()
{
	w32_copybmp();
}

bool	bcb_filetype(const char *src, const char *cnt_ext)
{
	char	*p, *e;
	char	*buf = new char[strlen(src)+1];
	char	*ext = new char[strlen(cnt_ext)+1];
	bool	rv = false;

	strcpy(buf, src);
	strcpy(ext, cnt_ext);
	strlwr(buf);
	strlwr(ext);

	p = strrchr(buf, '.');
	e = ext;
	if	( p )	{
		p ++;
		if	( *e == '.' )
			e ++;
		rv = (strcmp(e, p) == 0);
		}

	delete[] buf;
	delete[] ext;
	return rv;
}

/* ------------------------------------------------------------------------------------------------------------------- */

void _cdecl sbr_shell(void *unused)
{
	char	file[1024];

	running = 1;

	strcpy(file, bcb_srcfile);
    strcat(file, ".tmp.run");
    FMain->txtSource->Lines->SaveToFile(file);

	memmgr_init();
	memmgr_setabort(1);

	brun(file, 0);
	memmgr_close();

	w32_refresh();

    remove(file);

	running = 0;
}

/* ------------------------------------------------------------------------------------------------------------------- */

void	close_dev()
{
	if	( stdout_init )	{
		stdout_init = 0;
    	dev_restore();
		w32_stdout_close();
		delete bmp;
        bmp = NULL;
	    if	( !bcb_vs )
			FMain->imgOut->Align = alClient;
		}
}

void	reset_dev()
{
    TRect	rbmp;

	if	( stdout_init )
		close_dev();

	bmp = new Graphics::TBitmap;
    if	( !bcb_vs )	{
		rbmp.Left = 0; rbmp.Right  = FMain->imgOut->Width - 1;
		rbmp.Top  = 0; rbmp.Bottom = FMain->imgOut->Height - 1;
        }
    else	{
		rbmp.Left = 0; rbmp.Right  = bcb_vwidth - 1;
		rbmp.Top  = 0; rbmp.Bottom = bcb_vheight - 1;
		FMain->imgOut->Align = alNone;
		FMain->imgOut->Width = rbmp.Width();
		FMain->imgOut->Height = rbmp.Height();
    	}

	bmp->Height = rbmp.Height();
	bmp->Width  = rbmp.Width();
    bmp->Canvas->Brush->Color = (TColor) 0xFFFFFF;
    bmp->Canvas->FillRect(rbmp);

	w32_stdout_open();
    dev_init(1,1);
	stdout_init = 1;
}

/*
*	Send BREAK key to executor
*/
void	sbbreak()
{
	event_t	ev;

	if	( running )	{
		// send CTRL+C
		ev.type = EVKEY;
		ev.ch = 3;
		w32_evpush(&ev);
		}
}

/*
*	run (or restart) a program
*/
void	sbrun()
{
    if	( running )	{
    	Application->MessageBoxA("Program is running", "SBPad", MB_OK);
        return;
        }

	reset_dev();
    if	( bcb_srcfile[1] == ':' )	{
		char	*newdir = strdup(bcb_srcfile);
        char	*p = strrchr(newdir, '\\');

        if	( p )	{
        	*p = '\0';
            chdir(newdir);
        	}
	   	else
			chdir(bcb_dir);

        free(newdir);
    	}
   	else
		chdir(bcb_dir);

	if	( strlen(bcb_srcfile) )
		sbr_shell(NULL);
}

//---------------------------------------------------------------------------
__fastcall TFMain::TFMain(TComponent* Owner)
    : TForm(Owner)
{
	char		*p;
    String		s;
    int			n;
    TIniFile	*ini;

	sclOut->DoubleBuffered = true;
	strcpy(bcb_dir, Application->ExeName.c_str());
    p = strrchr(bcb_dir, '\\');
    *p = '\0';
	chdir(bcb_dir);

    //
    strcpy(bcb_srcfile, "untitled.bas");
    s.printf("SBPad - %s", bcb_srcfile);
    this->Caption = s;

	// read default vals
	ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
	bcb_ef = ini->ReadString("PAD", "EF", "Courier New,9");
	bcb_xf = ini->ReadString("PAD", "XF", "Courier New,9");
	bcb_vs = ini->ReadInteger("PAD", "VS", 0);
	bcb_vwidth  = ini->ReadInteger("PAD", "VW", 1024);
	bcb_vheight = ini->ReadInteger("PAD", "VH", 768);
	delete ini;

    bcb_strfont(bcb_ef, s, n);
    txtSource->Font->Name = s;
    txtSource->Font->Size = n;
    txtHelp->Font->Name = s;
    txtHelp->Font->Size = n;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::OnClose(TObject *Sender, TCloseAction &Action)
{
	int		r = IDYES;
    TIniFile	*ini;

    if	( running )	{
    	Application->MessageBoxA("Program is running", "SBPad", MB_OK);
    	Action = caNone;
        return;
        }
	if	( txtSource->Modified )	{
    	String	s;

		s.printf("Save changes to %s ?", bcb_srcfile);
    	if	( (r = Application->MessageBoxA(s.c_str(), "SBPad", MB_YESNOCANCEL)) == IDYES )
        	save_source();
        }
	if	( r != IDCANCEL )	{
		if	( stdout_init )
			close_dev();

		Action = caFree;

		// write default vals
		ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
		ini->WriteString("PAD", "EF", bcb_ef);
		ini->WriteString("PAD", "XF", bcb_xf);
		ini->WriteInteger("PAD", "VS", bcb_vs);
		ini->WriteInteger("PAD", "VW", bcb_vwidth);
		ini->WriteInteger("PAD", "VH", bcb_vheight);
		delete ini;
        }
	else
    	Action = caNone;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::Quit1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TFMain::Load1Click(TObject *Sender)
{
	TIniFile *ini;
    String	 dir, s;
    char	*p;
   	int		r = IDYES;

	if	( txtSource->Modified )	{
    	String	s;

		s.printf("Save changes to %s ?", bcb_srcfile);
    	if	( (r = Application->MessageBoxA(s.c_str(), "SBPad", MB_YESNOCANCEL)) == IDYES )
        	save_source();
       	if	( r == IDCANCEL )
        	return;
        }

	// read default dir
	ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
	dir = ini->ReadString("PAD", "LoadDir", "");
	delete ini;

    if	( dir.Length() )
    	dlgOpen->InitialDir = dir;

	if	( dlgOpen->Execute() )	{
    	strcpy(bcb_srcfile, dlgOpen->FileName.c_str());

        // store default dir
		p = strrchr(bcb_srcfile, '\\');
        if	( p )	{
        	*p = '\0';
			ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
			ini->WriteString("PAD", "LoadDir", bcb_srcfile);
			delete ini;
        	*p = '\\';
            }

        load_source();
		pgMain->ActivePageIndex = 0;
    	}
}
//---------------------------------------------------------------------------

void __fastcall TFMain::srcOnKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	update_sbar();
}
//---------------------------------------------------------------------------


void TFMain::update_sbar()
{
	String	st;
    int		i, l, c = 1, count = 0;

   	l = txtSource->Lines->Count + 1;
	for ( i = 0; i < txtSource->Lines->Count; i ++ ) {
    	if	( txtSource->SelStart >= (count + txtSource->Lines->Strings[i].Length() + 2) )	{
	    	count += txtSource->Lines->Strings[i].Length() + 2;
            }
        else	{
        	l = i + 1;
            c = ((txtSource->SelStart - count) + 1);
        	break;
        	}
    	}

    bcb_cur_line = l;
    bcb_cur_col  = c;
	st.printf("%s - %d:%d", bcb_srcfile, l, c);
    StatusBar1->SimpleText = st;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::Timer1Timer(TObject *Sender)
{
//	update_sbar();
	w32_refresh();
}
//---------------------------------------------------------------------------

void __fastcall TFMain::Find1Click(TObject *Sender)
{
	TFSearch	*frm;
    char		*curstr, *p;

	if	( strlen(bcb_search) == 0 )	{
    	frm = new TFSearch(this);

    	if	( frm->ShowModal() == mrOk )	{
        	strcpy(bcb_search, frm->txtText->Text.c_str());
            delete frm;
            }
		else	{
            delete frm;
        	return;
            }
		}

	if	( pgMain->ActivePageIndex == 3 )	{	// BC
    	curstr = strdup(txtBC->Text.c_str());
	    p = curstr + txtBC->SelStart + 1;
        }
	else if	( pgMain->ActivePageIndex == 1 )	{	// HLP
    	curstr = strdup(txtHelp->Text.c_str());
	    p = curstr + txtHelp->SelStart + 1;
    	}
    else	{
    	curstr = strdup(txtSource->Text.c_str());
	    p = curstr + txtSource->SelStart + 1;
        }

	if	( (unsigned) (p - curstr) < (unsigned) strlen(curstr) )	{
    	strlwr(p);
		strlwr(bcb_search);
		p = strstr(p, bcb_search);
        if	( p )	{
			if	( pgMain->ActivePageIndex == 3 )	{
				txtBC->SetFocus();
            	txtBC->SelStart = p - curstr;
				txtBC->SelLength = strlen(bcb_search);
                }
            else if	( pgMain->ActivePageIndex == 1 )	{
				txtHelp->SetFocus();
            	txtHelp->SelStart = p - curstr;
				txtHelp->SelLength = strlen(bcb_search);
            	}
		    else	{
				txtSource->SetFocus();
            	txtSource->SelStart = p - curstr;
				txtSource->SelLength = strlen(bcb_search);
                }
        	}
        else	// not found
        	Beep();
		}
    free(curstr);
}
//---------------------------------------------------------------------------

void __fastcall TFMain::Finx1Click(TObject *Sender)
{
	strcpy(bcb_search, "");
    Find1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TFMain::hlpOnClick(TObject *Sender)
{
	char	file[1024];
    int		idx;

    if	( lvHelp->Selected )	{
    	idx = lvHelp->Selected->Index;
	    sprintf(file, "%s\\%s", bcb_dir, bcb_hlpidx[idx]);
		txtHelp->Lines->LoadFromFile(file);
        txtHelp->Modified = false;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFMain::srcOnMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	update_sbar();
}
//---------------------------------------------------------------------------

void __fastcall TFMain::Save1Click(TObject *Sender)
{
	String	s;

    if	( strcmp(bcb_srcfile, "untitled.bas") == 0 )	{
    	Saveas1Click(Sender);
    	}
    else	{
    	save_source();

	    s.printf("SBPad - %s", bcb_srcfile);
	    this->Caption = s;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFMain::Restart1Click(TObject *Sender)
{
	pgMain->ActivePageIndex = 2;
	sbrun();
}
//---------------------------------------------------------------------------

void __fastcall TFMain::Break1Click(TObject *Sender)
{
	sbbreak();
}
//---------------------------------------------------------------------------

void __fastcall TFMain::outOnMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
	event_t	ev;

    ev.type = EVMOUSE;
    ev.button = 0;
    if	( Shift.Contains(ssLeft) )
    	ev.button |= 1;
    if	( Shift.Contains(ssRight) )
    	ev.button |= 2;
    if	( Shift.Contains(ssMiddle) )
    	ev.button |= 4;

    ev.x = X;
    ev.y = Y;
    w32_evpush(&ev);
}
//---------------------------------------------------------------------------


void __fastcall TFMain::outOnKeyPress(TObject *Sender, char &Key)
{
	event_t	ev;

    ev.type = EVKEY;
    ev.ch = Key;
    w32_evpush(&ev);
}
//---------------------------------------------------------------------------

void __fastcall TFMain::outOnKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	event_t	ev;

    ev.type = EVKEY;
    ev.ch = 0;
    switch ( Key )	{
    case	VK_UP:		ev.ch = SB_KEY_UP;  	break;
    case	VK_DOWN:	ev.ch = SB_KEY_DN;		break;
    case	VK_LEFT:	ev.ch = SB_KEY_LEFT;  	break;
    case	VK_RIGHT:	ev.ch = SB_KEY_RIGHT;	break;
    case	VK_PRIOR:	ev.ch = SB_KEY_PGUP;	break;
    case	VK_NEXT:	ev.ch = SB_KEY_PGDN;	break;

    case	VK_INSERT:	ev.ch = SB_KEY_INSERT;	break;
    case	VK_DELETE:	ev.ch = SB_KEY_DELETE;	break;
    case	VK_HOME:	ev.ch = SB_KEY_HOME;	break;
    case	VK_END:		ev.ch = SB_KEY_END;		break;

    case	VK_F1:		ev.ch = SB_KEY_F(1);	break;
    case	VK_F2:		ev.ch = SB_KEY_F(2);	break;
    case	VK_F3:		ev.ch = SB_KEY_F(3);	break;
    case	VK_F4:		ev.ch = SB_KEY_F(4);	break;
    case	VK_F5:		ev.ch = SB_KEY_F(5);	break;
    case	VK_F6:		ev.ch = SB_KEY_F(6);	break;
    case	VK_F7:		ev.ch = SB_KEY_F(7);	break;
    case	VK_F8:		ev.ch = SB_KEY_F(8);	break;
    case	VK_F9:		ev.ch = SB_KEY_F(9);	break;
    case	VK_F10:		ev.ch = SB_KEY_F(10);	break;
    case	VK_F11:		ev.ch = SB_KEY_F(11);	break;
    case	VK_F12:		ev.ch = SB_KEY_F(12);	break;

    case	VK_PAUSE:	ev.ch = 3;				break;	// the real BREAK :)
    	};

	if	( ev.ch )
	    w32_evpush(&ev);
}

//---------------------------------------------------------------------------


void __fastcall TFMain::outOnMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	event_t	ev;

    ev.type = EVMOUSE;
    ev.button = 0;
    if	( Shift.Contains(ssLeft) )
    	ev.button |= 1;
    if	( Shift.Contains(ssRight) )
    	ev.button |= 2;
    if	( Shift.Contains(ssMiddle) )
    	ev.button |= 4;

    ev.x = X;
    ev.y = Y;
    w32_evpush(&ev);
}
//---------------------------------------------------------------------------


void __fastcall TFMain::About1Click(TObject *Sender)
{
	TFAbout	*f = new TFAbout(this);

    f->ShowModal();
    delete f;	
}
//---------------------------------------------------------------------------

void __fastcall TFMain::Saveas1Click(TObject *Sender)
{
	TIniFile *ini;
    String	 dir, s;
    char	*p;

	// read default dir
	ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
	dir = ini->ReadString("PAD", "LoadDir", "");
	delete ini;

    if	( dir.Length() )
    	dlgSave->InitialDir = dir;

	if	( dlgSave->Execute() )	{
    	strcpy(bcb_srcfile, dlgSave->FileName.c_str());

        // store default dir
		p = strrchr(bcb_srcfile, '\\');
        if	( p )	{
        	*p = '\0';
			ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
			ini->WriteString("PAD", "LoadDir", bcb_srcfile);
			delete ini;
        	*p = '\\';
            }

		// save file
        save_source();

	    s.printf("SBPad - %s", bcb_srcfile);
	    this->Caption = s;
    	}
}
//---------------------------------------------------------------------------

void __fastcall TFMain::GenerateBC1Click(TObject *Sender)
{
	FILE	*fp;
    char	buf[1024];

    if	( running )	{
    	Application->MessageBoxA("Program is running", "SBPad", MB_OK);
        return;
        }

    reset_dev();
    memmgr_init();
	memmgr_setabort(1);

	brun_load(bcb_srcfile, 0);

	if	( !bc_get_error() )	{
	    strcpy(buf, bcb_dir);
	    strcat(buf, "\\sbpad.bc.txt");
		fp = fopen(buf, "wt");

		dump_bytecode(fp);
        }

    memmgr_close();
    fclose(fp);
	txtBC->Lines->LoadFromFile(buf);
    remove(buf);
	pgMain->ActivePageIndex = 3;
}
//---------------------------------------------------------------------------

void __fastcall TFMain::Settings1Click(TObject *Sender)
{
	TFSets *frm;

	frm = new TFSets(this);
    frm->txtEF->Text = bcb_ef;
    frm->txtXF->Text = bcb_xf;
    frm->chkVS->Checked = bcb_vs;
    frm->txtVW->Text = String(bcb_vwidth);
    frm->txtVH->Text = String(bcb_vheight);
    if	( bcb_vs == 0 )	{
	    frm->txtVW->Enabled = false;
	    frm->txtVH->Enabled = false;
    	}
	if	( frm->ShowModal() == mrOk )	{
    	bcb_ef = frm->txtEF->Text;
	    bcb_xf = frm->txtXF->Text;
	    bcb_vs = frm->chkVS->Checked;
	    bcb_vwidth = atoi(frm->txtVW->Text.c_str());
	    bcb_vheight = atoi(frm->txtVH->Text.c_str());
    	}
	delete frm;

    // apply editor's font
    String	s;
    int		n;
    
    bcb_strfont(bcb_ef, s, n);
    txtSource->Font->Name = s;
    txtSource->Font->Size = n;
    txtHelp->Font->Name = s;
    txtHelp->Font->Size = n;
}
//---------------------------------------------------------------------------


void __fastcall TFMain::New1Click(TObject *Sender)
{
	String		s;
    TDateTime	dt = TDateTime::CurrentDateTime();
    int			r = IDYES;

	if	( txtSource->Modified )	{
    	String	s;

		s.printf("Save changes to %s ?", bcb_srcfile);
    	if	( (r = Application->MessageBoxA(s.c_str(), "SBPad", MB_YESNOCANCEL)) == IDYES )
        	save_source();
       	if	( r == IDCANCEL )
        	return;
        }

	strcpy(bcb_srcfile, "untitled.bas");
    s = String("' ") + dt.DateTimeString() + String("\r\n");
	txtSource->Text = s;
	pgMain->ActivePageIndex = 0;
}
//---------------------------------------------------------------------------



void TFMain::load_source()
{
	String		s;

	if ( bcb_filetype(bcb_srcfile, ".pdb") )	{
        // PDB
		char	*buf;

		switch ( LoadSBPDB(bcb_srcfile, &buf) )	{
		case	-1:
		case	-2:
			warning("PDB2BAS-ERROR: Can't open file");
			break;
		case	-3:
			warning("PDB2BAS-ERROR: Texts > 32KB does not supported, yet.");
			break;
		case	-4:
			warning("PDB2BAS-ERROR: Bad signature.");
			break;
		default:
			txtSource->Text = String(buf);
			delete[] buf;
			}
		}
	else
		// open file
		txtSource->Lines->LoadFromFile(bcb_srcfile);

    s.printf("SBPad - %s", bcb_srcfile);
    this->Caption = s;
}

void TFMain::save_source()
{
	char	bak[1024];

    strcpy(bak, bcb_srcfile);
    strcat(bak, ".bak");
    copy_file(bcb_srcfile, bak);

	if ( bcb_filetype(bcb_srcfile, ".pdb") )	{
		String	s = txtSource->Text;
		switch ( SaveSBPDB(bcb_srcfile, s.c_str()) )	{
		case	-1:
			warning("BAS2PDB-ERROR: Can't create file");
			break;
		case	-3:
			warning("BAS2PDB-ERROR: Texts > 32KB does not supported, yet.");
			}
    	}
	else
	 	txtSource->Lines->SaveToFile(bcb_srcfile);
    txtSource->Modified = false;
}

void TFMain::copy_file(const char * src, const char * dst)
{
	FILE	*fin, *fout;
    char	buf[512];

	if	( (fin = fopen(src, "rt")) == NULL )
    	return;
	if	( (fout = fopen(dst, "wt")) == NULL )	{
    	fclose(fin);
        return;
        }

    while ( fgets(buf, 512, fin) )
    	fputs(buf, fout);

	fclose(fin);
    fclose(fout);
}
//---------------------------------------------------------------------------

